/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SPAM_LEX_NUMBER = 258,
     SPAM_LEX_STRING = 259,
     SPAM_LEX_VARIABLE = 260,
     SPAM_LEX_EQ = 261,
     SPAM_LEX_NEQ = 262,
     SPAM_LEX_APPROX_EQ = 263,
     SPAM_LEX_APPROX_NEQ = 264,
     SPAM_LEX_LE = 265,
     SPAM_LEX_GE = 266,
     SPAM_LEX_INC = 267
   };
#endif
/* Tokens.  */
#define SPAM_LEX_NUMBER 258
#define SPAM_LEX_STRING 259
#define SPAM_LEX_VARIABLE 260
#define SPAM_LEX_EQ 261
#define SPAM_LEX_NEQ 262
#define SPAM_LEX_APPROX_EQ 263
#define SPAM_LEX_APPROX_NEQ 264
#define SPAM_LEX_LE 265
#define SPAM_LEX_GE 266
#define SPAM_LEX_INC 267




/* Copy the first part of user declarations.  */
#line 1 "parse.y"


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <stdarg.h>
#include "eval.h"

#include "config.h"

#define SPAM_PARSE_ERR_MAX 10

typedef struct spam_parse_error
{
	const char *reason;
} spam_parse_error_t;

static spam_parse_error_t spam_parse_errlist[SPAM_PARSE_ERR_MAX] = {};

static spam_def_t *spamdef;
static spam_context_t *yyctx;

typedef void spam_parse_error_func(char *s, ...);
typedef struct spam_parse_func
{
	spam_parse_error_func *errfunc;
} spam_parse_func_t;

void yyerror(char *s);

void spam_parse_func_error_fprintf(char *s, ...)
{
	va_list ap;
	va_start(ap, s);
	vfprintf(stderr, s, ap);
	va_end(ap);
}

spam_parse_func_t spam_parse_funcset = { spam_parse_func_error_fprintf };

#define SPAM_PARSE_ERROR(arg...) ((spam_parse_funcset.errfunc)?spam_parse_funcset.errfunc( arg ):0)

static int spam_parse_error_count()
{
	int i;
	for( i = 0; spam_parse_errlist[i].reason != NULL || i == SPAM_PARSE_ERR_MAX; i++);
	return i;
}

static int spam_parse_error_init()
{
	int i, max = spam_parse_error_count();
	for( i = 0; i < max; i++ ) {
		free( (char *)spam_parse_errlist[i].reason );
		spam_parse_errlist[i].reason = NULL;
	}
    return 0;
}

static int spam_parse_error_add(spam_parse_error_t *newerror)
{
	int i = spam_parse_error_count();
	if( i == ( SPAM_PARSE_ERR_MAX ) ) {
		SPAM_PARSE_ERROR("Too many errors");
		return -1;
	} else if( i == ( SPAM_PARSE_ERR_MAX - 1 ) ) {
		if ( (spam_parse_errlist[i].reason = strdup("Too many errors")) == NULL ) {
			SPAM_PARSE_ERROR("spam_parse_error_add: %s\n", strerror(errno));
		}
		return -1;
	} else {
		spam_parse_errlist[i] = *newerror;
		if ( (spam_parse_errlist[i].reason = strdup(newerror->reason)) == NULL ) {
			SPAM_PARSE_ERROR("spam_parse_error_add: %s\n", strerror(errno));
			return -1;
		}
	}

	return i+1;
}

static int spam_parse_perror(char *prefix)
{
	spam_parse_error_t perr;
#ifdef SOLARIS8
	perr.reason = strerror(errno);
#else
	perr.reason = sys_errlist[errno];
#endif
	return spam_parse_error_add( &perr );
}

static void spam_print_cond_t(spam_cond_t *cond)
{
	switch( cond->type ) {
	case SPAM_COND_VARIABLE:
		SPAM_PARSE_ERROR("VAR:", cond->node.name );
	case SPAM_COND_STRING:
		SPAM_PARSE_ERROR("%s", cond->node.name );
		break;

	case SPAM_COND_NUMBER:
		SPAM_PARSE_ERROR("%d", cond->node.number );
		break;

	case SPAM_COND_EQ:
		SPAM_PARSE_ERROR("==" );
		break;

	case SPAM_COND_AND:
		SPAM_PARSE_ERROR("&" );
		break;

	default:
		SPAM_PARSE_ERROR("UNKNOWN");
		break;
	}

	SPAM_PARSE_ERROR(" ");
}

static void spam_print_cond_tree(spam_cond_t *cond)
{
	spam_print_cond_t(cond);
	if ( cond->children != NULL ) {
		SPAM_PARSE_ERROR("( ");
		spam_print_cond_tree(cond->children);
		SPAM_PARSE_ERROR(") ");
	}

	if ( cond->next_sibling != NULL ) {
			spam_print_cond_tree( cond->next_sibling);
	}

}

#if 0 /* unused */
static void spam_print_rule_t(spam_rule_t *rule)
{
	while( rule != NULL ) {
		SPAM_PARSE_ERROR( "rule: ");
		spam_print_cond_tree( rule->cond_tree );
		rule = rule->next_rule;
		SPAM_PARSE_ERROR("\n");
	}

}
#endif

static int spam_action_eval(spam_context_t *ctx, void *arg)
{
	spam_cond_eval( (spam_cond_t *)arg, ctx );
	return 0;
}

static int spam_parse_check_semantics( spam_cond_t *cond )
{
	if( yyctx->semantics != NULL ) {
		char *reason = yyctx->semantics( cond );
		if( reason != NULL ) {
			spam_parse_error_t e = { reason };
			if ( spam_parse_error_add( &e ) < 0 ) {
				free( reason );
				return -1;
			}
			free( reason );
		}
	}
	return 0;
}
extern char *yytext;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 176 "parse.y"
typedef union YYSTYPE {
	spam_cond_t cond, *condp;
	spam_rule_t *rulep;
	spam_action_t *actionp;
	int number;
	spam_cond_type type;
	char *string;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 293 "parse.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 305 "parse.c"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  10
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   40

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  21
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  19
/* YYNRULES -- Number of rules. */
#define YYNRULES  41
/* YYNRULES -- Number of states. */
#define YYNSTATES  56

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   267

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      18,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       5,     7,     2,     2,    20,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    17,     2,
      16,    19,    14,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       6,     8,     9,    10,    11,    12,    13,    15
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    17,    22,    24,    26,
      28,    30,    32,    34,    38,    40,    41,    45,    49,    51,
      53,    55,    57,    59,    64,    66,    68,    69,    73,    75,
      77,    79,    81,    83,    85,    87,    89,    91,    93,    95,
      99,   101
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      22,     0,    -1,    23,    -1,    24,    23,    -1,    24,    -1,
      27,    17,    28,    17,    38,    18,    -1,    25,    19,    30,
      18,    -1,    18,    -1,     6,    -1,     4,    -1,     4,    -1,
       3,    -1,    25,    -1,    29,    20,    28,    -1,    29,    -1,
      -1,    30,    36,    29,    -1,    30,    37,    29,    -1,    30,
      -1,    31,    -1,    26,    -1,     3,    -1,     6,    -1,    32,
       5,    33,     7,    -1,    26,    -1,    34,    -1,    -1,    35,
      20,    34,    -1,    35,    -1,    29,    -1,     8,    -1,    10,
      -1,    12,    -1,    13,    -1,    14,    -1,    16,    -1,    19,
      -1,     9,    -1,    11,    -1,    39,    20,    38,    -1,    39,
      -1,    29,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   198,   198,   202,   203,   207,   220,   227,   230,   240,
     250,   254,   259,   270,   286,   288,   304,   320,   349,   358,
     362,   372,   382,   403,   418,   431,   433,   439,   444,   448,
     452,   461,   470,   479,   488,   497,   506,   518,   528,   540,
     545,   549
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SPAM_LEX_NUMBER", "SPAM_LEX_STRING",
  "'('", "SPAM_LEX_VARIABLE", "')'", "SPAM_LEX_EQ", "SPAM_LEX_NEQ",
  "SPAM_LEX_APPROX_EQ", "SPAM_LEX_APPROX_NEQ", "SPAM_LEX_LE",
  "SPAM_LEX_GE", "'>'", "SPAM_LEX_INC", "'<'", "':'", "'\\n'", "'='",
  "','", "$accept", "spam_def", "rule_list", "rule", "variable", "string",
  "label", "cond_list", "cond", "unary", "func_call", "func_name",
  "func_arg", "arg_list", "arg", "expr_specifier",
  "negative_expr_specifier", "action_list", "action", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,    40,   260,    41,   261,   262,
     263,   264,   265,   266,    62,   267,    60,    58,    10,    61,
      44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    21,    22,    23,    23,    24,    24,    24,    25,    26,
      27,    27,    27,    28,    28,    28,    29,    29,    29,    29,
      30,    30,    30,    31,    32,    33,    33,    34,    34,    35,
      36,    36,    36,    36,    36,    36,    36,    37,    37,    38,
      38,    39
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     6,     4,     1,     1,     1,
       1,     1,     1,     3,     1,     0,     3,     3,     1,     1,
       1,     1,     1,     4,     1,     1,     0,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,    11,    10,     8,     7,     0,     2,     4,    12,     0,
       1,     3,     0,    15,    21,     9,    22,    20,     0,    20,
       0,    14,    18,    19,     0,     6,     0,    15,    30,    37,
      31,    38,    32,    33,    34,    35,    36,     0,     0,    26,
      41,     0,    40,    13,    16,    17,    29,     0,    25,    28,
       5,     0,    23,     0,    39,    27
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     5,     6,     7,     8,    19,     9,    20,    21,    22,
      23,    24,    47,    48,    49,    37,    38,    41,    42
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -27
static const yysigned_char yypact[] =
{
      -2,   -27,   -27,   -27,   -27,     3,   -27,    -2,   -12,    -8,
     -27,   -27,     2,     2,   -27,   -27,   -27,   -27,    -4,     5,
       0,    -5,    10,   -27,    23,   -27,     2,     2,   -27,   -27,
     -27,   -27,   -27,   -27,   -27,   -27,   -27,     2,     2,     2,
     -27,    12,    11,   -27,   -27,   -27,   -27,    25,   -27,    13,
     -27,     2,   -27,     2,   -27,   -27
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -27,   -27,    27,   -27,   -27,    24,   -27,     8,   -26,    26,
     -27,   -27,   -27,   -16,   -27,   -27,   -27,   -11,   -27
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -25
static const yysigned_char yytable[] =
{
      40,     1,     2,    10,     3,    14,    15,    12,    16,    13,
     -24,    44,    45,    46,    25,    27,     4,    26,    28,    29,
      30,    31,    32,    33,    34,    40,    35,    46,    39,    36,
      50,    51,    52,    53,    11,    43,    17,    55,    18,     0,
      54
};

static const yysigned_char yycheck[] =
{
      26,     3,     4,     0,     6,     3,     4,    19,     6,    17,
       5,    37,    38,    39,    18,    20,    18,    17,     8,     9,
      10,    11,    12,    13,    14,    51,    16,    53,     5,    19,
      18,    20,     7,    20,     7,    27,    12,    53,    12,    -1,
      51
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     4,     6,    18,    22,    23,    24,    25,    27,
       0,    23,    19,    17,     3,     4,     6,    26,    30,    26,
      28,    29,    30,    31,    32,    18,    17,    20,     8,     9,
      10,    11,    12,    13,    14,    16,    19,    36,    37,     5,
      29,    38,    39,    28,    29,    29,    29,    33,    34,    35,
      18,    20,     7,    20,    38,    34
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()
    ;
#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 198 "parse.y"
    {}
    break;

  case 5:
#line 208 "parse.y"
    {
				spam_rule_t *next_rule = spamdef->rule_list;
				spamdef->rule_list = (spam_rule_t *)malloc(sizeof(spam_rule_t));
				if( spamdef->rule_list == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				spamdef->rule_list->type = (yyvsp[-5].number);
				spamdef->rule_list->cond_tree = (yyvsp[-3].condp);
				spamdef->rule_list->next_rule = next_rule;
				spamdef->rule_list->action_list = (yyvsp[-1].actionp);
			}
    break;

  case 6:
#line 221 "parse.y"
    {
				spam_eval_t eval = spam_cond_eval(&(yyvsp[-1].cond), yyctx);
				yyctx->assign( (yyvsp[-3].string), yyctx, &eval );
				free( (yyvsp[-3].string) );
			}
    break;

  case 7:
#line 227 "parse.y"
    {}
    break;

  case 8:
#line 231 "parse.y"
    { 
				(yyval.string) = strdup(yytext);
				if( (yyval.string) == NULL ) {
					spam_parse_perror("strdup");
					YYABORT;
				}
			}
    break;

  case 9:
#line 241 "parse.y"
    { 
				(yyval.string) = strdup(yytext);
				if( (yyval.string) == NULL ) {
					spam_parse_perror("strdup");
					YYABORT;
				}
			}
    break;

  case 10:
#line 251 "parse.y"
    {
				(yyval.number) = (int) yytext; /* FIXME */
			}
    break;

  case 11:
#line 255 "parse.y"
    {
				(yyval.number) = atoi( yytext );
			}
    break;

  case 12:
#line 260 "parse.y"
    {
				if(( (yyval.number) = yyctx->lookup_ruleid( (yyvsp[0].string) ) ) < 0 ) {
					spam_parse_error_t err = { "Unknown Rule" };
					spam_parse_error_add(&err);
				}
				free( (yyvsp[0].string) );
			}
    break;

  case 13:
#line 271 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_AND,
					{ 0 },
					NULL, NULL
				};
				(yyval.condp) = (spam_cond_t *)malloc(sizeof(spam_cond_t));
				if( (yyval.condp) == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				*(yyval.condp) = cond;
				(yyval.condp)->children = (yyvsp[-2].condp);
				(yyval.condp)->children->next_sibling = (yyvsp[0].condp);
			}
    break;

  case 15:
#line 288 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_NUMBER,
					{ 1 },
					NULL, NULL
				};
				(yyval.condp) = (spam_cond_t *)malloc(sizeof(spam_cond_t));
				if( (yyval.condp) == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				*(yyval.condp) = cond;
		}
    break;

  case 16:
#line 305 "parse.y"
    {
				(yyval.condp) = (spam_cond_t *)malloc(sizeof(spam_cond_t));
				if( (yyval.condp) == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				*(yyval.condp) = (yyvsp[-1].cond);
				(yyval.condp)->children = (spam_cond_t *)malloc(sizeof(spam_cond_t));
				if( (yyval.condp)->children == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				*(yyval.condp)->children = (yyvsp[-2].cond);
				(yyval.condp)->children->next_sibling = (yyvsp[0].condp);
			}
    break;

  case 17:
#line 321 "parse.y"
    {
				spam_cond_t ncond = {
					SPAM_COND_NOT,
					{ 0 },
					NULL, NULL
				};

				spam_cond_t *cond = (spam_cond_t *)malloc(sizeof(spam_cond_t));
				if( cond == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				(yyval.condp) = (spam_cond_t *)malloc(sizeof(spam_cond_t));
				if( (yyval.condp) == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				*(yyval.condp) = ncond;
				*cond = (yyvsp[-1].cond);
				cond->children = (spam_cond_t *)malloc(sizeof(spam_cond_t));
				if( cond->children == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				*cond->children = (yyvsp[-2].cond);
				cond->children->next_sibling = (yyvsp[0].condp);
				(yyval.condp)->children = cond;
			}
    break;

  case 18:
#line 350 "parse.y"
    {
				(yyval.condp) = (spam_cond_t *)malloc(sizeof(spam_cond_t));
				if( (yyval.condp) == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				*(yyval.condp) = (yyvsp[0].cond);
			}
    break;

  case 20:
#line 363 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_STRING,
					{ 0 },
					NULL, NULL
				};
				cond.node.name = (yyvsp[0].string);
				(yyval.cond) = cond;
			}
    break;

  case 21:
#line 373 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_NUMBER,
					{ 0 },
					NULL, NULL
				};
				cond.node.number = atoi(yytext);
				(yyval.cond) = cond;
			}
    break;

  case 22:
#line 383 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_VARIABLE,
					{ 0 },
					NULL, NULL
				};
				cond.node.name = strdup(yytext);
				if( cond.node.name == NULL ) {
					spam_parse_perror("strdup");
					YYABORT;
				}
				(yyval.cond) = cond;
				if( spam_parse_check_semantics( &(yyval.cond) ) < 0 ) {
					YYABORT;
				}

			}
    break;

  case 23:
#line 404 "parse.y"
    {
				spam_cond_t *cond =
					(spam_cond_t *)malloc(sizeof(spam_cond_t));
				if( cond == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				cond->type = SPAM_COND_FUNC_CALL;
				cond->node.name = (yyvsp[-3].cond).node.name;
				(yyval.condp) = cond;
				(yyval.condp)->next_sibling = (yyvsp[-1].condp);
			}
    break;

  case 24:
#line 419 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_STRING,
					{ 0 },
					NULL, NULL
				};
				(yyval.cond) = cond;
				(yyval.cond).node.name = (yyvsp[0].string);
			}
    break;

  case 26:
#line 433 "parse.y"
    {
			(yyval.condp) = NULL;
		}
    break;

  case 27:
#line 440 "parse.y"
    {
				(yyvsp[-2].condp)->next_sibling = (yyvsp[0].condp);
				(yyval.condp) = (yyvsp[-2].condp);
			}
    break;

  case 30:
#line 453 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_EQ,
					{ 0 },
					NULL, NULL
				};
				(yyval.cond) = cond;
			}
    break;

  case 31:
#line 462 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_APPROX_EQ,
					{ 0 },
					NULL, NULL
				};
				(yyval.cond) = cond;
			}
    break;

  case 32:
#line 471 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_LE,
					{ 0 },
					NULL, NULL
				};
				(yyval.cond) = cond;
			}
    break;

  case 33:
#line 480 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_GE,
					{ 0 },
					NULL, NULL
				};
				(yyval.cond) = cond;
			}
    break;

  case 34:
#line 489 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_GT,
					{ 0 },
					NULL, NULL
				};
				(yyval.cond) = cond;
			}
    break;

  case 35:
#line 498 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_LT,
					{ 0 },
					NULL, NULL
				};
				(yyval.cond) = cond;
			}
    break;

  case 36:
#line 507 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_ASSIGN,
					{ 0 },
					NULL, NULL
				};
				(yyval.cond) = cond;
			}
    break;

  case 37:
#line 519 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_EQ,
					{ 0 },
					NULL, NULL
				};
				(yyval.cond) = cond;
			}
    break;

  case 38:
#line 529 "parse.y"
    {
				spam_cond_t cond = {
					SPAM_COND_APPROX_EQ,
					{ 0 },
					NULL, NULL
				};
				(yyval.cond) = cond;
			}
    break;

  case 39:
#line 541 "parse.y"
    {
				(yyval.actionp) = (yyvsp[-2].actionp);
				(yyvsp[-2].actionp)->next_action = (yyvsp[0].actionp);
			}
    break;

  case 41:
#line 550 "parse.y"
    {
				(yyval.actionp) = (spam_action_t *)malloc(sizeof(spam_action_t));
				if( (yyval.actionp) == NULL ) {
					spam_parse_perror("malloc");
					YYABORT;
				}
				(yyval.actionp)->action = spam_action_eval;
				(yyval.actionp)->arg = (void *)(yyvsp[0].condp);
				(yyval.actionp)->next_action = NULL;
			}
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 1740 "parse.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 563 "parse.y"


extern FILE *yyin;

spam_def_t *spam_parse_def(FILE *fin, spam_context_t *ctx)
{
	int i;
	int max;
	yyin = fin;
	yyctx = ctx;
	spamdef = (spam_def_t *)malloc(sizeof(spam_def_t));
	if( spamdef == NULL ) {
		SPAM_PARSE_ERROR("spam_parse_def: %s\n", strerror(errno));
		return NULL;
	}
	spamdef->rule_list = NULL;
	spam_parse_error_init();
	while( !feof(yyin) ) {
		yyparse();
		if( (max = spam_parse_error_count()) > 0 ) {
			for( i = 0; i < max; i++ ) {
				SPAM_PARSE_ERROR("E: %s\n", spam_parse_errlist[i].reason);
			}
			free( spamdef );
			spamdef = NULL;
		}
	}
	spam_parse_error_init();
	return spamdef;
}

static void spam_cond_free( spam_cond_t *cond )
{
	switch( cond->type ) {
	case SPAM_COND_VARIABLE:
	case SPAM_COND_STRING:
		free( (char *)cond->node.name );
		break;
    default:
        break;
	}

	if ( cond->children != NULL ) {
		spam_cond_free( cond->children );
		cond->children = NULL;
	}

	if ( cond->next_sibling != NULL ) {
		spam_cond_free( cond->next_sibling );
		cond->next_sibling = NULL;
	}
	free( cond );

}

static void spam_action_free( spam_action_t *action_list )
{
	if ( action_list->next_action != NULL ) {
		spam_action_free( action_list->next_action );
		action_list->next_action = NULL;
	}
	spam_cond_free( (spam_cond_t *)action_list->arg );
}

static void spam_rule_list_free( spam_rule_t *rule_list )
{
	if ( rule_list->next_rule != NULL ) {
		spam_rule_list_free( rule_list->next_rule );
		rule_list->next_rule = NULL;
	}

	spam_cond_free( rule_list->cond_tree );
	rule_list->cond_tree = NULL;
	spam_action_free( rule_list->action_list );
	rule_list->action_list = NULL;

}

void spam_free_def( spam_def_t *def )
{
	spam_rule_list_free( def->rule_list);
	def->rule_list = NULL;
	free( def );
}

void yyerror(char *s)
{
	spam_parse_error_t err;
	err.reason = s;
	SPAM_PARSE_ERROR("%s\n", s);
	spam_parse_error_add( &err );
}


